;FileName:386SCD.ASM

DESCRIPTOR      STRUC
        LIMITL          DW      0     
        BASEL           DW      0     
        BASEM           DB      0       
        ATTRIBUTES      DW      0     
        BASEH           DB      0     
DESCRIPTOR      ENDS
;-------------------------------------------------------
GATE    STRUC                           
        OFFSETL         DW      0     
        SELECTOR        DW      0       
        DCOUNT          DB      0     
        GTYPE           DB      0       
        OFFSETH         DW      0     
GATE    ENDS
;--------------------------------------------------------
PDESC   STRUC
        LIMIT   DW      0     
        BASE    DD      0     
PDESC ends
;-----------------------------------------------------------
TASKSS  STRUC
        TRLINK          DW      ?,0     
 
        TRESP0          DD      ?     
        TRSS0           DW      ?,0     
        TRESP1          DD      ?     
        TRSS1           DW      ?,0     
        TRESP2          DD      ?     
        TRSS2           DW      ?,0
   TRCR3           DD      ?       ;CR3
        TREIP           DD      ?       ;EIP
        TREFLAG         DW      ?,?     ;EFLAGS
 
        TREAX           DD      ?       ;EAX
        TRECX           DD      ?       ;ECX
        TREDX           DD      ?       ;EDX
        TREBX           DD      ?       ;EBX
        TRESP           DD      ?       ;ESP
        TREBP           DD      ?       ;EBP
        TRESI           DD      ?       ;ESI
        TREDI           DD      ?       ;EDI
        TRES            DW      ?,0     ;ES
        TRCS            DW      ?,0     ;CS
        TRSS            DW      ?,0     ;SS
        TRDS            DW      ?,0     ;DS
        TRFS            DW      ?,0     ;FG
        TRGS            DW      ?,0     ;GS
 
        TRLDT           DW      ?,0     ;LDT
 
        TRFLAG          DW      0       
        TRIOMAP         DW      $+2     
TASKSS  ENDS
;--------------------------------------------------------------
ATDR            =       90H             
ATDW            =       92H           
ATDWA           =       93H           
ATCE            =       98H           
ATCER           =       9AH           
ATCCO           =       9CH           
ATCCOR          =       9EH           
;
ATLDT           =       82H           
ATTASKGAT       =       85H           
AT386TSS        =       89H             
AT386CGAT       =       8CH           
AT386IGAT       =       8EH           
AT386TGAT       =       8FH           
;------------------------------------------------------------------
;
DPL1    =       20H                     ;DPL=1
DPL2    =       40H                     ;DPL=2
DPL3    =       60H                     ;DPL=3
RPL1    =       01H                     ;RPL=1
RPL2    =       02H                     ;RPL=2
RPL3    =       03H                     ;RPL=3
IOPL1   =       1000H                   ;IOPL=1
IOPL2   =       2000H                   ;IOPL=2
IOPL3   =       3000H                   ;IOPL=3
;-------------------------------------------------------
;
D32     =       4000H                 
TIL     =       04H                   
VMFL    =       0002H                 
IFL     =       0200H                 
;-----------------------------------------------
;
JUMP32  MACRO   selector, offsetv
        DB      0EAH           
        DW      offsetv         
        DW      0
        DW      selector       
        ENDM
;-----------------------------------------------
;
CALL32  MACRO   selector, offsetv
        DB      9AH           
        DW      offsetv       
        DW      0
        DW      selector       
        ENDM
;----------------------------------------------
;
JUMP16  MACRO   selector, offsetv
        DB      0EAH           
        DW      offsetv         
        DW      selector       
        ENDM
;---------------------------------------------
;
CALL16  MACRO   selector, offsetv
        DB      9AH           
        DW      offsetv         
        DW      selector       
        ENDM
